<template>
    <div>
        <section class="hero">
            <div class="hero-body">
                <p class="title">
                    Edit Profile
                </p>
            </div>
        </section>
        <section class="section">
            <h3 class="title">Basic info</h3>
            <form>
                <b-field label="First name">
                    <b-input
                        pattern="[A-zÀ-ÖØ-öø-įĴ-őŔ-žǍ-ǰǴ-ǵǸ-țȞ-ȟȤ-ȳɃɆ-ɏḀ-ẞƀ-ƓƗ-ƚƝ-ơƤ-ƥƫ-ưƲ-ƶẠ-ỿ'\- ]+"
                        required
                        ref="first_name"
                        v-model="profile.first_name"
                        validation-message="First name may only consist of letters and spaces"
                    ></b-input>
                </b-field>
                <b-field label="Middle name (optional)">
                    <b-input
                        pattern="[A-zÀ-ÖØ-öø-įĴ-őŔ-žǍ-ǰǴ-ǵǸ-țȞ-ȟȤ-ȳɃɆ-ɏḀ-ẞƀ-ƓƗ-ƚƝ-ơƤ-ƥƫ-ưƲ-ƶẠ-ỿ'\- ]*"
                        ref="middle_name"
                        validation-message="Middle name may only consist of letters and spaces"
                        v-model="profile.middle_name"
                    ></b-input>
                </b-field>
                <b-field label="Last name">
                    <b-input
                        required
                        ref="last_name"
                        pattern="[A-zÀ-ÖØ-öø-įĴ-őŔ-žǍ-ǰǴ-ǵǸ-țȞ-ȟȤ-ȳɃɆ-ɏḀ-ẞƀ-ƓƗ-ƚƝ-ơƤ-ƥƫ-ưƲ-ƶẠ-ỿ'\- ]+"
                        validation-message="Last name may only consist of letters and spaces"
                        v-model="profile.last_name"
                    ></b-input>
                </b-field>
            </form>
        </section>
        <section class="section">
            <h3 class="title">Contact</h3>
            <form>
                <b-field label="Email">
                    <b-input
                        required
                        type="email"
                        ref="email"
                        pattern="[a-zA-Z0-9_@\-.]+"
                        v-model="profile.email"
                        validation-message="Invalid email address"
                    ></b-input>
                </b-field>
                <b-field label="Phone number">
                    <b-input
                        required
                        type="tel"
                        v-model="profile.phone_number"
                        ref="phone_number"
                        maxlength="19"
                        minlength="10"
                        pattern="[0-9+ \- \(\)]+"
                        validation-message="Include country code. For example for US (+1) (555)-555-5555 or UK +44 (0)1234 567890"
                    ></b-input>
                </b-field>
                <b-field label="Github username (optional)">
                    <b-input
                        ref="github"
                        pattern="[a-zA-Z0-9\-]*"
                        maxlength="40"
                        validation-message="Username may only consist of letters and numbers and hyphens"
                        v-model="profile.github"
                    ></b-input>
                </b-field>
                <b-field label="LinkedIn username (optional)">
                    <b-input
                        pattern="[a-zA-Z0-9_\-:/.]*"
                        v-model="profile.linkedin"
                        ref="linkedin"
                    ></b-input>
                </b-field>
                <b-field label="Personal website (optional)">
                    <b-input
                        ref="website"
                        pattern="[a-zA-Z0-9_\-:/.]*"
                        v-model="profile.website"
                    ></b-input>
                </b-field>
            </form>
        </section>
        <section class="section">
            <h3 class="title">Account</h3>
            <form>
                <b-field label="Username">
                    <b-input
                        required
                        ref="username"
                        maxlength="20"
                        pattern="[a-zA-Z0-9_]+"
                        validation-message="Username may only consist of letters, underscores, and numbers"
                        v-model="profile.username"
                    ></b-input>
                </b-field>
                <b-field label="Change password">
                    <b-input
                        type="password"
                        password-reveal
                        v-model="changePassword"
                        ref="changePassword"
                        pattern="[A-za-z0-9 !@#\$%\^&\*\(\)\-=\[\].,:;<>?]+"
                        minlength="8"
                        validation-message="Passwords need to be at least 8 characters long"
                    ></b-input>
                </b-field>
                <b-field label="Change password confirmation">
                    <b-input
                        type="password"
                        password-reveal
                        v-model="changePasswordConfirm"
                        ref="changePasswordConfirm"
                        pattern="[A-za-z0-9 !@#\$%\^&\*\(\)\-=\[\].,:;<>?]+"
                        minlength="8"
                        validation-message="Passwords need to be at least 8 characters long"
                    ></b-input>
                </b-field>
            </form>
        </section>
        <section class="section">
            <h3 class="title">Update profile</h3>
            <b-button type="is-primary" @click="confirmUpdate">Update</b-button>
        </section>
    </div>
</template>
<script>
 import isEmail from 'validator/lib/isEmail';
 import isURL from 'validator/lib/isURL';
 export default {
     name: 'EditProfile',
     data() {
         return {
             profile: {},
             changePassword: '',
             changePasswordConfirm: '',
         }
     },
     methods: {
         getCurrentProfile() {
             // fetch current info from database
             fetch('/api/user/info')
                 .then((response) => {
                     if (response.ok) {
                         response.json().then((res) => {
                             this.profile = res.user
                             return
                         })
                     }
                 })
                 .catch((e) => { console.error(e) })
         },
         validateProfile() {
             // validate the new data
             if (!(this.profile.first_name && this.profile.last_name && this.profile.email && this.profile.username && this.profile.phone_number)) {
                 return "Make sure you've filled in all required fields. "
             }
             if (this.changePassword) {
                 if (this.changePassword !== this.changePasswordConfirm) {
                     return "If you want to change your password, make sure they match. "
                 }
                 if (this.changePassword.length < 8) {
                     return "Passwords must be at least 8 characters long"
                 }
                 if (this.changePassword.match(/[^A-za-z0-9 !@#$%^&*()\-=[\].,:;<>?]/)) {
                     return "Invalid characters in password"
                 }
             }
             let fields = [
                 'first_name',
                 'middle_name',
                 'last_name',
                 'phone_number',
                 'email',
                 'username',
                 'changePassword',
                 'changePasswordConfirm',
                 'github',
                 'linkedin',
                 'website'
             ]
             for (let i=0; i<fields.length; i++) {
                 if (!this.$refs[fields[i]].checkHtml5Validity()) {
                     return `Validation error in ${fields[i]}`
                 }
             }
             // now we replicate the backend logic --- lots of overlap with the previous check
             let nameRegex = /[^A-zÀ-ÖØ-öø-įĴ-őŔ-žǍ-ǰǴ-ǵǸ-țȞ-ȟȤ-ȳɃɆ-ɏḀ-ẞƀ-ƓƗ-ƚƝ-ơƤ-ƥƫ-ưƲ-ƶẠ-ỿ'\- ]/;
             if (!this.profile.username || this.profile.username.match(/[^a-zA-Z0-9]/) || this.profile.username.length > 20) {
                 return "Validation error in username";
             }
             if (!this.profile.first_name || this.profile.first_name.match(nameRegex)) {
                 return "Validation error in first name";
             }
             if (this.profile.middle_name) {
                 if (this.profile.middle_name.match(nameRegex)) {
                     return "Validation error in midlde name";
                 }
             }
             if (!this.profile.last_name || this.profile.last_name.match(nameRegex)) {
                 return "Validation error in last name";
             }
             if (!this.profile.email || !isEmail(this.profile.email)) {
                 return "Validation error in email";
             }
             if (this.profile.github) {
                 if (this.profile.github.match(/[^a-zA-Z0-9-]/)) {
                     return "Validation error in Github username";
                 }
             }
             if (this.profile.linkedin) {
                 if (!isURL(this.profile.linkedin)) {
                     return "Validation error in LinkedIn URL";
                 }
             }
             if (this.profile.website) {
                 if (!isURL(this.profile.website)) {
                     return "Validation error in personal website URL";
                 }
             }
             if (!this.profile.phone_number || this.profile.phone_number.match(/[^0-9+ \- ()]/) || this.profile.phone_number.length > 19 || this.profile.phone_number.length < 10) {
                 return "Validation error in phone number";
             }
             return false
         },
         confirmUpdate() {
             let valErrors = this.validateProfile()
             if (!valErrors) {
                 this.$buefy.dialog.prompt({
                     message: "Enter your (old) password to confirm changes",
                     inputAttrs: {
                         type: 'password'
                     },
                     trapFocus: true,
                     closeOnConfirm: false,
                     onConfirm: (value, { close }) => {
                         this.postNewProfile(value, close)
                     }
                 })
             } else {
                 this.$buefy.toast.open({
                     duration: 3000,
                     message: valErrors,
                     position: 'is-bottom',
                     type: 'is-danger',
                     queue: false
                 })
             }
         },
         postNewProfile(oldPassword, close) {
             // update database with new data
             fetch('/api/user/update', {
                 method: 'PUT',
                 headers: {
                     'Content-Type': 'application/json;charset=utf-8'
                 },
                 body: JSON.stringify({
                     old_password: oldPassword,
                     email: this.profile.email,
                     username: this.profile.username,
                     password: this.changePassword,
                     first_name: this.profile.first_name,
                     middle_name: this.profile.middle_name,
                     last_name: this.profile.last_name,
                     github: this.profile.github,
                     linkedin: this.profile.linkedin,
                     website: this.profile.website,
                     phone_number: this.profile.phone_number
                 })
             }).then((response) => {
                 if (response.ok) {
                     this.$buefy.toast.open({
                         duration: 3000,
                         message: 'Profile successfully updated',
                         position: 'is-bottom',
                         type: 'is-success',
                         queue: false
                     })
                     close()
                 } else {
                     if (response.status === 409) {
                         // username or email conflict
                         this.$buefy.toast.open({
                             duration: 3000,
                             message: 'That username, email, or phone number is already in use',
                             position: 'is-bottom',
                             type: 'is-danger',
                             queue: false
                         })
                         close()
                         return
                     }
                     if (response.status === 405) {
                         this.$buefy.toast.open({
                             duration: 3000,
                             message: 'Backend validation check failed',
                             position: 'is-bottom',
                             type: 'is-danger',
                             queue: false
                         })
                         close()
                         return
                     }
                     if (response.status === 401) {
                         this.$buefy.toast.open({
                             duration: 2000,
                             message: "Incorrect password",
                             position: 'is-bottom',
                             type: 'is-danger',
                             queue: false
                         })
                         return
                     }
                     this.$buefy.toast.open({
                         duration: 3000,
                         message: 'Something went wrong',
                         position: 'is-bottom',
                         type: 'is-danger',
                         queue: false
                     })
                 }
             })
         }
     },
     created() {
         this.getCurrentProfile()
     }
 }
</script>
